//+------------------------------------------------------------------+
//|                                          Guppy MMA oscilator.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  clrGreen
#property indicator_color2  clrRed
#property indicator_color3  clrDarkGray
#property indicator_color4  clrLimeGreen
#property indicator_color5  clrPaleVioletRed
#property indicator_width4  2
#property indicator_level1  0

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame            = PERIOD_CURRENT;
extern ENUM_APPLIED_PRICE Price                = PRICE_CLOSE;
extern int                SignalPeriod         = 13;
extern bool               alertsOn             = true;
extern bool               alertsOnCurrent      = false;
extern bool               alertsMessage        = true;
extern bool               alertsSound          = false;
extern bool               alertsEmail          = false;
extern bool               alertsNotify         = false;
extern bool               verticalLinesVisible = false;
extern bool               linesOnFirst         = true;
extern string             verticalLinesID      = "gmma Lines";
extern color              verticalLinesUpColor = clrDeepSkyBlue;
extern color              verticalLinesDnColor = clrPaleVioletRed;
extern ENUM_LINE_STYLE    verticalLinesStyle   = STYLE_DOT;
extern int                verticalLinesWidth   = 0;

//
//
//
//
//

double buffer1[];
double buffer2[];
double hup[];
double hdn[];
double trend[];
double diff[];
double periods[]={3,5,8,10,12,15,30,35,40,45,50,60};
int    persize;
string indicatorFileName;
bool   returnBars;

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,hup); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,hdn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,diff);
   SetIndexBuffer(3,buffer1);
   SetIndexBuffer(4,buffer2);
   SetIndexBuffer(5,trend);
   persize =ArraySize(periods);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
      
      //
      //
      //
      //
      //

   IndicatorShortName(timeFrameToString(TimeFrame)+" Guppy MMA oscillator");
   return(0);
}
int deinit() 
{ 
   deleteLines();
return(0); 
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   double alpha = 2.0/(1.0+SignalPeriod);
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { hup[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame == Period())
   {
      for(int i=limit; i>=0; i--)
      {
         double sum  = 0;
         for(int j=0; j<persize; j++)
         {
            if (periods[j]<30)
                  sum  += iMA(NULL,0,periods[j],0,MODE_EMA,Price,i);
            else  sum  -= iMA(NULL,0,periods[j],0,MODE_EMA,Price,i);
         }
         buffer1[i] = sum*10.0;
         buffer2[i] = buffer2[i+1]+alpha*(buffer1[i]-buffer2[i+1]);
         hup[i]   = EMPTY_VALUE;
         hdn[i]   = EMPTY_VALUE;
         trend[i] = trend[i+1];
         diff[i]  = buffer1[i]-buffer2[i];
            if (diff[i]>0)     trend[i] = 1;
            if (diff[i]<0)     trend[i] =-1;
            if (trend[i] == 1) hup[i]   = diff[i]; 
            if (trend[i] ==-1) hdn[i]   = diff[i];
            
            //
            //
            //
            //
            //
         
            if (verticalLinesVisible)
            {
              deleteLine(Time[i]);
              if (trend[i]!=trend[i+1])
              {
                 if (trend[i] == 1) drawLine(i,verticalLinesUpColor);
                 if (trend[i] ==-1) drawLine(i,verticalLinesDnColor);
              }
            }      
      } 
      
     //
     //
     //
     //
     //
   
     if (alertsOn)
     {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;
        if (trend[whichBar] != trend[whichBar+1])
        {
           if (trend[whichBar] == 1) doAlert(whichBar,"up");
           if (trend[whichBar] ==-1) doAlert(whichBar,"down");
        }         
     }          
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         hup[i]     = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Price,SignalPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,verticalLinesVisible,linesOnFirst,verticalLinesID,verticalLinesUpColor,verticalLinesDnColor,verticalLinesStyle,verticalLinesWidth,0,y);
         hdn[i]     = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Price,SignalPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,verticalLinesVisible,linesOnFirst,verticalLinesID,verticalLinesUpColor,verticalLinesDnColor,verticalLinesStyle,verticalLinesWidth,1,y);
         diff[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Price,SignalPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,verticalLinesVisible,linesOnFirst,verticalLinesID,verticalLinesUpColor,verticalLinesDnColor,verticalLinesStyle,verticalLinesWidth,2,y);
         buffer1[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Price,SignalPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,verticalLinesVisible,linesOnFirst,verticalLinesID,verticalLinesUpColor,verticalLinesDnColor,verticalLinesStyle,verticalLinesWidth,3,y);
         buffer2[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Price,SignalPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,verticalLinesVisible,linesOnFirst,verticalLinesID,verticalLinesUpColor,verticalLinesDnColor,verticalLinesStyle,verticalLinesWidth,4,y);
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message = StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)+" Guppy MMA oscillator ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Guppy MMA oscillator "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//
//
//
//
//

void drawLine(int i,color theColor)
{
      string name = verticalLinesID+":"+Time[i];
   
      //
      //
      //
      //
      //
      
      int add = 0; if (!linesOnFirst) add = _Period*60-1;
      ObjectCreate(name,OBJ_VLINE,0,Time[i]+add,0);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,verticalLinesStyle);
         ObjectSet(name,OBJPROP_WIDTH,verticalLinesWidth);
         ObjectSet(name,OBJPROP_BACK,true);
}

//
//
//
//
//

void deleteLines()
{
   string lookFor       = verticalLinesID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteLine(datetime time)
{
   string lookFor = verticalLinesID+":"+time; ObjectDelete(lookFor);
}
